import scala.actors._
import Actor._

val symbols = List( "AAPL", "GOOG", "IBM", "JAVA", "MSFT")

def getYearEndClosing(symbol : String, year : Int) = {
  val url = "http://ichart.finance.yahoo.com/table.csv?s=" +
    symbol + "&a=11&b=01&c=" + year + "&d=11&e=31&f=" + year + "&g=m"
    
  val data = io.Source.fromURL(url).mkString
  val price = data.split("\n")(1).split(",")(4).toDouble  
  (symbol, price)
} 

val start = System.nanoTime()

val caller = self

symbols.foreach { symbol =>
  actor { caller ! getYearEndClosing(symbol, 2008) } 
}

val maxStock = (("", -1.0) /: symbols) { (maxStock, sym) =>
  receive {
    case (symbol: String, price: Double) =>
      if (price > maxStock._2)
        (symbol, price)
      else
        maxStock
  }
}

val end = System.nanoTime()
                   
println("High stock is " + maxStock._1 + " with price " + maxStock._2)
println(end - start)