val symbols = List( "AAPL", "GOOG", "IBM", "JAVA", "MSFT")

def getYearEndClosing(symbol : String, year : Int) = {
  val url = "http://ichart.finance.yahoo.com/table.csv?s=" +
    symbol + "&a=11&b=01&c=" + year + "&d=11&e=31&f=" + year + "&g=m"
    
  val data = io.Source.fromURL(url).mkString
  val price = data.split("\n")(1).split(",")(4).toDouble  
  price
} 

val start = System.nanoTime()

val maxStock = (("", -1.0) /: symbols) {(maxStock, symbol) =>
  val price = getYearEndClosing(symbol, 2008)
  if(price > maxStock._2)
    (symbol, price)
  else
    maxStock
}

val end = System.nanoTime()
                   
println("High stock is " + maxStock._1 + " with price " + maxStock._2)
println(end - start)